﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Line : MonoBehaviour
{


    // EN DEV
    List<Path> paths;
    private bool onDraw;
    private Vector2 startPoint;
    private LineRenderer lineGFX;
    public LineRenderer lineDrawing;
    private Collider2D col;
    private bool fromBegining;
    Path tmpPath = null;

    //TMP
    public GameObject testVaisseau;
    private void Awake()
    {
        onDraw = false;
        paths = new List<Path>();
        col = GetComponent<Collider2D>();
        lineGFX = GetComponent<LineRenderer>();
        lineGFX.startWidth = 0.2f;
        lineGFX.endWidth = 0.2f;
        lineGFX.numCornerVertices = 10;
        lineGFX.startColor = Color.cyan;
        lineGFX.endColor = Color.cyan;
        lineGFX.material.mainTexture.wrapMode = TextureWrapMode.Repeat;
        lineDrawing.startWidth = 0.2f;
        lineDrawing.endWidth = 0.2f;
        lineDrawing.numCornerVertices = 10;
        lineDrawing.startColor = Color.cyan;
        lineDrawing.endColor = Color.cyan;
        lineDrawing.material.mainTexture.wrapMode = TextureWrapMode.Repeat;
    }

    private void Update()
    {
        Vector2 mouseposition = Camera.main.ScreenToWorldPoint(Input.mousePosition);
        ControllerManager(mouseposition);
        if (onDraw)
        {
            tmpPath = new Path(Astar.FindPath(startPoint, mouseposition));
        }
        DrawPath();
    }

    private void ControllerManager(Vector2 mouseposition)
    {
        if (Input.GetMouseButtonDown(0))
        {

            CircleCollider2D collision = (CircleCollider2D)Physics2D.OverlapPoint(mouseposition);
            Vector2 colliderPosition = collision.gameObject.transform.position;
            if (collision != null && collision.tag == "Planet")
            {
                //Si je commence pas alors je dois check si je suis sur la première Node ou sur le Deniere Node
                if (paths.Count > 0)
                {
                    //Test si sur premiere node ou  derniere node.
                    if (Vector3.Distance(colliderPosition, paths[0].GetStartPoint()) < collision.radius)
                    {
                        fromBegining = true;
                        onDraw = true;
                        startPoint = collision.gameObject.transform.position;
                        lineDrawing.enabled = true;
                    }
                    else if (Vector3.Distance(colliderPosition, paths[paths.Count - 1].GetEndPoint()) < collision.radius)
                    {
                        fromBegining = false;
                        onDraw = true;
                        startPoint = collision.gameObject.transform.position;
                        lineDrawing.enabled = true;
                    }
                }
                else
                {
                    fromBegining = false;
                    onDraw = true;
                    startPoint = collision.gameObject.transform.position;
                    lineDrawing.enabled = true;
                }
            }
        }
        if (Input.GetMouseButtonUp(0))
        {
            if (onDraw)
            {
                Collider2D collision = Physics2D.OverlapPoint(mouseposition);
                if (collision != null && collision.tag == "Planet")
                {
                    onDraw = false;
                    if (fromBegining)
                        paths.Insert(0, new Path(Astar.FindPath(collision.gameObject.transform.position, startPoint)));
                    else
                        paths.Add(new Path(Astar.FindPath(startPoint, collision.gameObject.transform.position)));
                    testVaisseau.GetComponent<VaiselController>().SetPath(paths);
                    RemoveTmpPath();
                }
                else
                {
                    onDraw = false;
                    RemoveTmpPath();
                }
            }
        }
    }

    private void DrawPath()
    {
        if (paths != null && paths.Count > 0)
        {
            lineGFX.positionCount = 1;
            int global = 0;
            foreach (Path p in paths)
            {
                Vector2[] pointsToDraw = p.GetPoints();
                lineGFX.positionCount += pointsToDraw.Length - 1;
                for (int i = 0; i < pointsToDraw.Length - 1; i++)
                {
                    lineGFX.SetPosition(global, pointsToDraw[i]);
                    global++;
                }

            }
            lineGFX.SetPosition(global, paths[paths.Count - 1].GetEndPoint());
        }
        if(tmpPath != null)
        {
            Vector2[] pointsToDraw = tmpPath.GetPoints();
            lineDrawing.positionCount = pointsToDraw.Length;
            for (int i = 0; i < pointsToDraw.Length; i++)
            {
                lineDrawing.SetPosition(i, pointsToDraw[i]);
            }
        }
    }

    void RemoveTmpPath()
    {
        tmpPath = null;
        lineDrawing.enabled = false;
    }
    /*private void OnDrawGizmos()
    {
           if(matrice != null)
        {
            foreach(Node n in matrice.matrice)
            {
                Gizmos.color = Color.black;
                for(int i = 0; i < tmpPath.GetPoints().Length; i++)
                {
                    if(tmpPath.GetPoints()[i] == n.worldPosition)
                    {
                        Gizmos.color = Color.blue;
                    }
                }
                float nodeDiameter = 0.1f;
                Gizmos.DrawCube(n.worldPosition, Vector3.one * (nodeDiameter - (nodeDiameter / 10)));
            }
        }
    }*/
}
