﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlanetDisplay : MonoBehaviour
{

	public Planet Planet;

	private float _metalAmount;
	private float _quartzAmount;
	private float _voidiumAmount;
	
	
	public void Awake()
	{
		MetalAmount = 0;
		QuartzAmount = 0;
		VoidiumAmount = 0;
		Debug.Log("planet");
	}
	
	
	// Use this for initialization
	void Start ()
	{
		Planet.print();
		GetComponent<SpriteRenderer>().sprite = Planet.Artwork;
	}

	public void UpdateProduction(float deltaTime)
	{
		MetalAmount += Planet.MetalCoef * deltaTime;
		QuartzAmount += Planet.QuartzCoef * deltaTime;
		VoidiumAmount += Planet.VoidiumCoef * deltaTime;
	}
	
	
	public float MetalAmount
	{
		get { return _metalAmount; }
		set { _metalAmount = value; }
	}

	public float QuartzAmount
	{
		get { return _quartzAmount; }
		set { _quartzAmount = value; }
	}

	public float VoidiumAmount
	{
		get { return _voidiumAmount; }
		set { _voidiumAmount = value; }
	}
	
	public float LoadMetal(float _maxAmount)
	{
		float toLoad = getLoad(_maxAmount, _metalAmount);
		_metalAmount = _metalAmount - toLoad;
		return toLoad;
	}

	public float LoadQuartz(float _maxAmount)
	{
		float toLoad = getLoad(_maxAmount, _quartzAmount);
		_quartzAmount = _quartzAmount - toLoad;
		return toLoad;
	}

	public float LoadVoidium(float _maxAmount)
	{
		float toLoad = getLoad(_maxAmount, _voidiumAmount);
		_voidiumAmount = _voidiumAmount - toLoad;
		return toLoad;
	}

	private float getLoad(float capacity, float disponibility)
	{
		return Math.Min(capacity, disponibility);
	}
}
